#ifndef CANIMAL_H
#define CANIMAL_H

class CAnimal {
protected:
    char* name;
    float weight;
public:
    CAnimal(const char* animalName, float animalWeight);
    ~CAnimal();
    double GetFoodCaloriesPerDay() const;
    const char* GetName() const;
};

class CCat : public CAnimal {
public:
    CCat(const char* animalName, float animalWeight) : CAnimal(animalName, animalWeight) {}
    double GetFoodCaloriesPerDay() const;
};

class CDog : public CAnimal {
public:
    CDog(const char* animalName, float animalWeight) : CAnimal(animalName, animalWeight) {}
    double GetFoodCaloriesPerDay() const;
};

class CHorse : protected CAnimal {
public:
    CHorse(const char* animalName, float animalWeight) : CAnimal(animalName, animalWeight) {}
    double GetFoodCaloriesPerDay() const;
    using CAnimal::GetName;
};

#endif // CANIMAL_H
